%global srcname pOCCI
%global commit e75b95b3906ab0d890d152c0855894f9cbd0a7db
%global shortcommit %(c=%{commit}; echo ${c:0:7})

# compatibility macros
%{!?py2_build:%global py2_build %{__python2} setup.py build --executable="%{__python2} -s"}
%{!?py2_install:%global py2_install %{__python2} setup.py install -O1 --skip-build --root %{buildroot}}
%{!?py3_build:%global py3_build %{__python3} setup.py build --executable="%{__python3} -s"}
%{!?py3_install:%global py3_install %{__python3} setup.py install -O1 --skip-build --root %{buildroot}}
%if 0%{?rhel} && 0%{?rhel} <= 6
%{!?__python2: %global __python2 /usr/bin/python2}
%{!?python_provide: %global python_provide Provides: python-%{srcname} = %{version}-%{release}}
%{!?python2_version: %global python2_version %(%{__python2} -c "import sys; sys.stdout.write(sys.version[:3])")}
%{!?python2_sitelib: %global python2_sitelib %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python2_sitearch: %global python2_sitearch %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%endif

# no python 3 in EL <= 7
%if 0%{?rhel}
%global with_python3 0
%else
%global with_python3 1
%endif

# incompatible unittest module in EL <= 6
%if 0%{?rhel} && 0%{?rhel} <= 6
%global with_tests 0
%else
%global with_tests 1
%endif

Name:           python-%{srcname}
Version:        0.0.1
Release:        0.20150827git%{shortcommit}%{?dist}
Summary:        OCCI compliance testing

License:        MIT
URL:            https://github.com/CESNET/pOCCI
Source0:        https://github.com/CESNET/%{srcname}/archive/%{commit}/%{srcname}-%{commit}.tar.gz
# enable 2to3 with workarounds for buggy setuptools
# (not intended for inclusion in the code)
Patch1:          %{srcname}-2to3.diff

BuildArch:      noarch
BuildRequires:  python2-devel python-pycurl
%if 0%{?with_python3}
BuildRequires:  python3-devel python3-pycurl
%endif
BuildRequires:  python-sphinx

%description
OCCI compliance testing.


%package -n python2-%{srcname}
Summary:        %{summary}
BuildArch:      noarch
Requires:       python-pycurl
Requires:       python-setuptools
%{?python_provide:%python_provide python2-%{srcname}}

%description -n python2-pOCCI
OCCI compliance testing.

%if 0%{?with_python3}

%package -n python3-%{srcname}
Summary:        %{summary}
Requires:       python3-pycurl
Requires:       python3-setuptools
%{?python_provide:%python_provide python3-%{srcname}}

%description -n python3-%{srcname}
OCCI compliance testing.

%endif

%package doc
Summary:        Documentation for %{srcname}

%description doc
User and API documentation for OCCI compliance testing python modules.


%prep
%setup -qc
pushd %{srcname}-%{commit}
%patch1 -p1
%if 0%{?rhel} && 0%{?rhel} <= 6
sed -e "/'sphinx.ext.viewcode'/d" -i doc/conf.py
%endif
popd
cp -a %{srcname}-%{commit} python2
cp -a %{srcname}-%{commit} python3


%build
pushd python2
%py2_build
make html
rm -f build/html/.buildinfo
popd

%if 0%{?with_python3}
pushd python3
%py3_build
popd
%endif


%install
pushd python2
%py2_install
popd
cp -p %{buildroot}%{_bindir}/pOCCI %{buildroot}%{_bindir}/pOCCI-%{python2_version}
rm -f %{buildroot}%{python2_sitelib}/%{srcname}/pOCCI.cfg
rm -rf %{buildroot}%{python2_sitelib}/tests
chmod +x %{buildroot}%{python2_sitelib}/%{srcname}/pOCCI.py

%if 0%{?with_python3}
pushd python3
%py3_install
cp -p %{buildroot}%{_bindir}/pOCCI %{buildroot}%{_bindir}/pOCCI-%{python3_version}
rm -f %{buildroot}%{python3_sitelib}/%{srcname}/pOCCI.cfg
rm -rf %{buildroot}%{python3_sitelib}/tests
chmod +x %{buildroot}%{python3_sitelib}/%{srcname}/pOCCI.py
rm -f %{buildroot}%{python3_sitelib}/%{srcname}/pOCCI.1
popd
%endif

mkdir -p %{buildroot}%{_mandir}/man1
mv %{buildroot}%{python2_sitelib}/%{srcname}/pOCCI.1 %{buildroot}%{_mandir}/man1/
rm -f %{buildroot}%{_sysconfdir}/pOCCI.cfg


%check
%if 0%{?with_tests}
pushd python2
%{__python2} setup.py test
popd

%if 0%{?with_python3}
# workaround problems with tests in setuptools
pushd python3/build/lib/tests
%{__python3} ./test_parse_http.py
%{__python3} ./test_parse_text.py
%{__python3} ./test_parse_uri.py
popd
%endif
%endif


%{!?_licensedir:%global license %doc}

%files -n python2-%{srcname}
%license python2/LICENSE
%doc python2/README.rst
%doc python2/%{srcname}/pOCCI.cfg
%{python2_sitelib}/%{srcname}/
%{python2_sitelib}/%{srcname}-%{version}*.egg-info/
%{_bindir}/pOCCI-2*
%{_mandir}/man1/pOCCI.1*
%if ! 0%{?with_python3}
%{_bindir}/pOCCI
%endif

%if 0%{?with_python3}
%files -n python3-%{srcname}
%license python3/LICENSE
%doc python3/README.rst
%doc python3/%{srcname}/pOCCI.cfg
%{python3_sitelib}/%{srcname}/
%{python3_sitelib}/%{srcname}-%{version}*.egg-info/
%{_bindir}/pOCCI
%{_bindir}/pOCCI-3*
%{_mandir}/man1/pOCCI.1*
%endif

%files doc
%doc python2/build/html/


%changelog
* Thu Aug 27 2015 František Dvořák <valtri@civ.zcu.cz> - 0.0.1-0.20150827gite75b95d
- Initial package
